/*
 * Copyright 2009 Prime Technology.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.primefaces.event;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

public class ItemSelectEvent extends FacesEvent {
	
	private int itemIndex;
	
	private int seriesIndex;

	public ItemSelectEvent(UIComponent source, int itemIndex, int seriesIndex) {
		super(source);
		this.itemIndex = itemIndex;
		this.seriesIndex = seriesIndex;
	}

	@Override
	public boolean isAppropriateListener(FacesListener listener) {
		return false;
	}

	@Override
	public void processListener(FacesListener listener) {
		throw new UnsupportedOperationException();
	}
	
	public int getItemIndex() {
		return itemIndex;
	}

	public int getSeriesIndex() {
		return seriesIndex;
	}
}